﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication117
{
    public partial class Form1 : Form
    {
        ContextMenu cm;
        private Point mouseLocation;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cm = new ContextMenu();
            cm.MenuItems.Add("Open");
            cm.MenuItems.Add("Delete",eventForDelete);
            cm.MenuItems.Add("Show",eventForShow);
            button2.ContextMenu = cm;
            button1.MouseMove += myMouseMove;
            button1.MouseDown += myMouseDown;
            button2.MouseMove += myMouseMove;
            button2.MouseDown += myMouseDown;
        }
        public void eventForDelete(Object sender, EventArgs e)
        {
            button2.Visible = false;
        }
        public void eventForShow(Object sender, EventArgs e)
        {
            MessageBox.Show("Button Show Event!");
        }
        private void myMouseDown(Object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
                mouseLocation = e.Location;
        }
        private void myMouseMove(Object sender, MouseEventArgs e)
        {
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                //if (sender.GetType()==typeof(Button))
                Button b = (Button)sender;
                b.Left = e.X + b.Left - mouseLocation.X;
                b.Top = e.Y + b.Top - mouseLocation.Y;
            }
        }
    }
}
